<?php
/**
 * Created by PhpStorm.
 * User: erikasantos
 * Date: 08/04/14
 * Time: 14:00
 */

namespace Geral\Logic\Cadastros\Organizacao\Estrutura;



class Filial {

    const TIPOESTRUTURA = 2;

    public static function nova ($nrorg, $razaosocialfili, $nmfilial, $cnpj, $cdinscesta, $cdinscmuni, $cdempresa,
                                 $cdcomunicaparc, $cdpais, $sgestado, $cdmunicipio)
    {

        $filial = self::novaFilial($nrorg, $razaosocialfili, $nmfilial, $cnpj, $cdinscesta, $cdinscmuni, $cdempresa);

        $estrutura = \Geral\Logic\Cadastros\Organizacao\Estrutura::nova(
            $nrorg, self::TIPOESTRUTURA, '01/01/2000', $nmfilial, $cdcomunicaparc, $cdpais, $sgestado,
            $cdmunicipio
        );
        $estrutura->persist();
        \Setforms2\Shared\Registry::getEntityManager()->flush();

        return $filial;
    }

    /**
     * @param $nrorg
     * @param $razaosocialfili
     * @param $nmfilial
     * @param $cnpj
     * @param $cdinscesta
     * @param $cdinscmuni
     * @param $cdempresa
     * @return \Geral\Entities\Filial
     */
    private static function novaFilial($nrorg, $razaosocialfili, $nmfilial, $cnpj, $cdinscesta, $cdinscmuni, $cdempresa)
    {
        //gera cdfilial
        $i=1;
        for($i; $i<10000; $i++){
            $obj = \Geral\Entities\Filial::getObjectByWhere('TO_NUMBER (CDFILIAL) = ?', array($i));
            if(!$obj){
                break;
            }
        }

        while (strlen($i)<4){
            $i = '0'.$i;
        }

        $filial = new \Geral\Entities\Filial();
        $filial->setNrorg($nrorg);
        $filial->setCdfilial($i);
        $filial->setNmfilial($nmfilial);
        $filial->setCdempresa($cdempresa);
        $filial->setCdinscmuni($cdinscmuni);
        $filial->setCdinscesta($cdinscesta);
        $filial->setNrinsjurfili($cnpj);
        $filial->setNmrazsocfili($razaosocialfili);
        $filial->setIdendemisfil('P');
        $filial->setIdendcfopfil('P');
        $filial->setIdcumupiscofil('S');
        $filial->setIdutiloffline('N');
        $filial->setDtultatu(\Geral\Util\DateUtil::getDataAtual());
        $filial->setDtinclusao(\Geral\Util\DateUtil::getDataAtual());
        $filial->setCdoperinclusao(\Geral\Util\Ambiente::getCdOperador());


        return $filial;
    }

} 